import matplotlib.pyplot as plt
from matplotlib import colors
import numpy as np

class Plotter:
    def __init__(self):
        self.topFig, self.topAx = plt.subplots();

         
    def plotConvergence(self, convg, sameFig = True):
        plt.figure();
        
        for key in convg:
            y = np.array(convg[key]);
            plt.semilogy(y, label = str(key));
            if(sameFig == False):
                plt.xlabel('Iterations');
                plt.ylabel(str(key));
                plt.grid('True')
                plt.figure();
        if(sameFig):
            plt.title('Convergence Plots' );
            plt.xlabel('Iterations');
            plt.legend(loc='lower left', shadow=True, fontsize='large');

    def plotDensity(self, xy, density, titleStr, saveFig, retainPlot = False):
        plt.ion();
        plt.clf();
        if(retainPlot):
            fig, ax = self.topFig, self.topAx;
        else:
            fig, ax = plt.subplots();
        plt.subplot(1,1,1);

        plt.imshow(-np.flipud(density.T), cmap='gray',\
                    interpolation='none',norm=colors.Normalize(vmin=-1,vmax=0))
  
        plt.axis('Equal')
        plt.title(titleStr)
        plt.grid(False)
        
        fig.canvas.draw();
        plt.pause(0.01)
        
        if(saveFig['isOn']):
            fig.savefig(saveFig['name'], bbox_inches='tight', pad_inches=0);


        

